#include <glib.h>
#include "df-object.h"
#include "df-lamp.h"

/*
 * Methods
 */
static void
turn_off(DF__Lamp *self)
{
	g_return_if_fail(self != NULL);

	self->state = FALSE;
}

static void
turn_on(DF__Lamp *self)
{
	g_return_if_fail(self != NULL);

	self->state = TRUE;
}

/* Overriding function */
static void
destroy(DF__Lamp *self)
{
	/* Here we do destruction */
	self->state = FALSE;

	/* Call parent implementation */
	DF__Lamp__ParentMethods->destroy(self->cast.DF__Object);
}

/*
 * Init functions
 */
static void
init_methods(DF__Lamp__Methods *methods)
{
	/* overrides */
	methods->destroy = destroy;

	/* our methods */
	methods->turn_off = turn_off;
	methods->turn_on = turn_on;
}

static void
init_interfaces(DF__Lamp__Interfaces *interfaces)
{
}

static void
init_data(DF__Lamp *self)
{
	self->state = FALSE;
}

/*
 * Definitions macro
 */
DF__OBJECT_DEFINITIONS(DF__Lamp,DF__Object,init_methods,init_interfaces,init_data);
